summaryrefslogtreecommitdiffstats
path: root/core/traffic_controller.py
blob: 428e91f88d889b01643491de912a3e055d0ed917 (plain)
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
# Copyright 2015 Intel Corporation.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""Interface to traffic controllers
"""

class ITrafficController(object):
    """Abstract class which defines a traffic controller object

    Used to setup and control a traffic generator for a particular deployment
    scenario.
    """

    def send_traffic(self, traffic):
        """Triggers traffic to be sent from the traffic generator.

        This is a blocking function.

        :param traffic: A dictionary describing the traffic to send.
        """
        raise NotImplementedError(
            "The TrafficController does not implement",
            "the \"send_traffic\" function.")

    def send_traffic_async(self, traffic, function):
        """Triggers traffic to be sent  asynchronously.

        This is not a blocking function.

        :param traffic: A dictionary describing the traffic to send.
        :param function: A dictionary describing the function to call between
             send and wait in the form:
             function = {
                 'function' : package.module.function,
                 'args' : args
             }
             If this function requires more than one argument, all should be
             should be passed using the args list and appropriately handled.
         """
        raise NotImplementedError(
            "The TrafficController does not implement",
            "the \"send_traffic_async\" function.")

    def stop_traffic(self):
        """Kills traffic being sent from the traffic generator.
        """
        raise NotImplementedError(
            "The TrafficController does not implement",
            "the \"stop_traffic\" function.")
ght .no { color: #003366; font-weight: bold } /* Name.Constant */ .highlight .nd { color: #555555 } /* Name.Decorator */ .highlight .ne { color: #bb0066; font-weight: bold } /* Name.Exception */ .highlight .nf { color: #0066bb; font-weight: bold } /* Name.Function */ .highlight .nl { color: #336699; font-style: italic } /* Name.Label */ .highlight .nn { color: #bb0066; font-weight: bold } /* Name.Namespace */ .highlight .py { color: #336699; font-weight: bold } /* Name.Property */ .highlight .nt { color: #bb0066; font-weight: bold } /* Name.Tag */ .highlight .nv { color: #336699 } /* Name.Variable */ .highlight .ow { color: #008800 } /* Operator.Word */ .highlight .w { color: #bbbbbb } /* Text.Whitespace */ .highlight .mb { color: #0000DD; font-weight: bold } /* Literal.Number.Bin */ .highlight .mf { color: #0000DD; font-weight: bold } /* Literal.Number.Float */ .highlight .mh { color: #0000DD; font-weight: bold } /* Literal.Number.Hex */ .highlight .mi { color: #0000DD; font-weight: bold } /* Literal.Number.Integer */ .highlight .mo { color: #0000DD; font-weight: bold } /* Literal.Number.Oct */ .highlight .sa { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Affix */ .highlight .sb { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Backtick */ .highlight .sc { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Char */ .highlight .dl { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Delimiter */ .highlight .sd { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Doc */ .highlight .s2 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Double */ .highlight .se { color: #0044dd; background-color: #fff0f0 } /* Literal.String.Escape */ .highlight .sh { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Heredoc */ .highlight .si { color: #3333bb; background-color: #fff0f0 } /* Literal.String.Interpol */ .highlight .sx { color: #22bb22; background-color: #f0fff0 } /* Literal.String.Other */ .highlight .sr { color: #008800; background-color: #fff0ff } /* Literal.String.Regex */ .highlight .s1 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Single */ .highlight .ss { color: #aa6600; background-color: #fff0f0 } /* Literal.String.Symbol */ .highlight .bp { color: #003388 } /* Name.Builtin.Pseudo */ .highlight .fm { color: #0066bb; font-weight: bold } /* Name.Function.Magic */ .highlight .vc { color: #336699 } /* Name.Variable.Class */ .highlight .vg { color: #dd7700 } /* Name.Variable.Global */ .highlight .vi { color: #3333bb } /* Name.Variable.Instance */ .highlight .vm { color: #336699 } /* Name.Variable.Magic */ .highlight .il { color: #0000DD; font-weight: bold } /* Literal.Number.Integer.Long */ }
#!/bin/bash
##############################################################################
# Copyright (c) 2015 Ericsson AB and others.
#
# All rights reserved. This program and the accompanying materials
# are made available under the terms of the Apache License, Version 2.0
# which accompanies this distribution, and is available at
# http://www.apache.org/licenses/LICENSE-2.0
##############################################################################

#
# Set up the environment and run yardstick test suites.
#
# Example invocation: yardstick-verify -r 10.4.4.4 suite1.yaml suite2.yaml
#
# Openstack credentials must be set and the script must be run from its
# original location in the yardstick repo.
#
# This script is intended to be used by the CI pipeline but it may also
# be invoked manually.
#

SCRIPT=$0
SCRIPT_ARGS=$@

usage()
{
    cat << EOF
usage: $0 options [TEST_SUITE ...]

If no test suites are given ping.yaml is run.

OPTIONS:
   -h      Show this message
   -r      Http target (example: -r 213.77.62.197/results)
   -i      Influxdb target (example: -i 127.0.0.1:8086)
   -m      Reporting target (example: -m 213.77.62.197/results)

           Default target is dump to file ($DISPATCHER_FILE_NAME)

EOF
}

DISPATCHER_TYPE=file
DISPATCHER_FILE_NAME="/tmp/yardstick.out"
DISPATCHER_HTTP_TARGET="http://testresults.opnfv.org/test/api/v1/results"
DISPATCHER_INFLUXDB_TARGET=
REPORTING_TARGET="${DISPATCHER_HTTP_TARGET}"

while getopts "r:i:m:h" OPTION; do
    case $OPTION in
        h)
            usage
            exit 0
            ;;
        r)
            DISPATCHER_TYPE=http
            DISPATCHER_HTTP_TARGET=http://${OPTARG}
            DISPATCHER_FILE_NAME=
            ;;
        i)
            DISPATCHER_TYPE=influxdb
            DISPATCHER_INFLUXDB_TARGET=http://${OPTARG}
            DISPATCHER_FILE_NAME=
            ;;
        m)
            REPORTING_TARGET=http://${OPTARG}
            ;;
        *)
            echo "${OPTION} is not a valid argument"
            exit 1
            ;;
    esac
done

shift $[OPTIND - 1]
TEST_SUITES=$@

exitcode=""

error_exit()
{
    local rc=$?

    if [ -z "$exitcode" ]; then
        # In case of recursive traps (!?)
        exitcode=$rc
    fi

    cleanup

    echo "Exiting with RC=$exitcode"

    exit $exitcode
}

set -o errexit
set -o pipefail

install_storperf()
{
    # Install Storper on huawei-pod1 and huawei-pod2
    if [ "$NODE_NAME" == "huawei-pod1" -o "$NODE_NAME" == "huawei-pod2" ]; then
        echo
        echo "========== Installing storperf =========="

        if ! yardstick -d plugin install plugin/CI/storperf.yaml; then
            echo "Install storperf plugin FAILED";
            exit 1
        fi

    fi
}

remove_storperf()
{
    # remove Storper from huawei-pod1 and huawei-pod2
    if [ "$NODE_NAME" == "huawei-pod1" -o "$NODE_NAME" == "huawei-pod2" ]; then
        echo
        echo "========== Removing storperf =========="

        if ! yardstick -d plugin remove plugin/CI/storperf.yaml; then
            echo "Remove storperf plugin FAILED";
            exit 1
        fi

    fi
}

report(){

    echo
    echo "========== Reporting Status =========="
    curl -i -H 'content-type: application/json' -X POST -d \
        "{\"project_name\": \"yardstick\",
          \"case_name\": \"scenario_status\",
          \"pod_name\":\"${NODE_NAME}\",
          \"installer\":\"${INSTALLER_TYPE}\",
          \"version\":\"$(basename ${YARDSTICK_BRANCH})\",
          \"scenario\":\"${DEPLOY_SCENARIO}\",
          \"description\": \"yardstick ci scenario status\",
          \"criteria\":\"${1}\",
          \"start_date\":\"${2}\",
          \"stop_date\":\"${3}\",
          \"details\":\"\"}" \
          "${REPORTING_TARGET}"
}

run_test()
{
    echo
    echo "========== Running yardstick test suites =========="

    mkdir -p /etc/yardstick

    cat << EOF > /etc/yardstick/yardstick.conf
[DEFAULT]
debug = False
dispatcher = ${DISPATCHER_TYPE}

[dispatcher_file]
file_name = ${DISPATCHER_FILE_NAME}

[dispatcher_http]
timeout = 5
target = ${DISPATCHER_HTTP_TARGET}

[dispatcher_influxdb]
timeout = 5
target = ${DISPATCHER_INFLUXDB_TARGET}
db_name = yardstick
username = opnfv
password = 0pnfv2015
EOF

    local failed=0
    local start_date
    local stop_date

    if [ ${#SUITE_FILES[@]} -gt 0 ]; then

        start_date=$(date '+%Y-%m-%d %H:%M:%S')
        for suite in ${SUITE_FILES[*]}; do

            echo "---------------------------"
            echo "Running test suite: $suite"
            echo "---------------------------"
            if ! yardstick task start --suite $suite; then
                 echo "test suite $suite FAILED";

                # Mark the test suite failed but continue
                # running the remaining test suites.
                (( ++failed ))
            fi
            if [ ${DISPATCHER_TYPE} = file ]; then
                echo "---------------------------"
                echo "Dump test suite $suite result"
                echo "---------------------------"
                if [ -f ${DISPATCHER_FILE_NAME} ]; then
                    cat ${DISPATCHER_FILE_NAME}
                else
                    echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
                fi
            fi
        done
        stop_date=$(date '+%Y-%m-%d %H:%M:%S')



        local scenario_status="SUCCESS"

        if [ $failed -gt 0 ]; then
            scenario_status="FAILED"
        fi

        report "${scenario_status}" "${start_date}" "${stop_date}"

        if [ $failed -gt 0 ]; then
            echo "---------------------------"
            echo "$failed out of ${SUITE_FILES[*]} test suites FAILED"
            echo "---------------------------"
            exit 1
        fi

    else

        echo "---------------------------"
        echo "Running samples/ping.yaml  "
        echo "---------------------------"

        if ! yardstick task start samples/ping.yaml; then
            echo "Yardstick test FAILED"
            exit 1
        fi

        if [ ${DISPATCHER_TYPE} = file ]; then
            echo "---------------------------"
            echo "Dump samples/ping.yaml test result"
            echo "---------------------------"
            if [ -f ${DISPATCHER_FILE_NAME} ]; then
                cat ${DISPATCHER_FILE_NAME}
            else
                echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
            fi
        fi

    fi

}

main()
{
    GITROOT=$(cd $(dirname $0) && git rev-parse --show-toplevel)

    cd $GITROOT

    export YARDSTICK_VERSION=$(git rev-parse HEAD)

    SUITE_FILES=()

    # find the test suite files
    for suite in $TEST_SUITES; do
        if [ -f $suite ]; then
            SUITE_FILES+=($suite)
        else
            tsdir=$GITROOT/tests/opnfv/test_suites
            if [ ! -f $tsdir/$suite ]; then
                echo "Test suite \"$suite\" does not exist"
                exit 1
            fi
            SUITE_FILES+=($tsdir/$suite)
        fi
    done

    echo
    echo "========== Running Yardstick CI with following parameters =========="
    echo "Script options: ${SCRIPT} $SCRIPT_ARGS"
    echo "Dispatcher: ${DISPATCHER_TYPE} ${DISPATCHER_FILE_NAME}"
    echo "YARDSTICK_VERSION: ${YARDSTICK_VERSION}"
    echo "Number of test suites: ${#SUITE_FILES[@]}"
    for suite in ${SUITE_FILES[*]}; do
        echo "     $suite"
    done
    echo

    # check if some necessary variables is set
    if [ -z "$OS_AUTH_URL" ]; then
        echo "OS_AUTH_URL is unset or empty"
        exit 1
    fi

    echo "OS_AUTH_URL is $OS_AUTH_URL"
    echo

    # check OpenStack services
    if [[ $OS_INSECURE ]] && [[ "$(echo $OS_INSECURE | tr '[:upper:]' '[:lower:]')" = "true" ]]; then
        SECURE="--insecure"
    else
        SECURE=""
    fi
    echo "Checking OpenStack services:"
    for cmd in "openstack ${SECURE} image list" "openstack ${SECURE} server list" "openstack ${SECURE} stack list"; do
        echo "  checking ${cmd} ..."
        if ! $cmd >/dev/null; then
            echo "error: command \"$cmd\" failed"
            exit 1
        fi
    done

    echo
    echo "Checking for External network:"
    for net in $(openstack network list --external -c Name -f value); do
        echo "  external network: $net"
    done

    source $YARDSTICK_REPO_DIR/tests/ci/clean_images.sh

    trap "error_exit" EXIT SIGTERM

    source $YARDSTICK_REPO_DIR/tests/ci/load_images.sh
    install_storperf
    run_test
    remove_storperf
}

main